// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: proto/ecdsa.proto

package com.google.crypto.tink.proto;

/**
 * Protobuf enum {@code google.crypto.tink.EcdsaSignatureEncoding}
 */
public enum EcdsaSignatureEncoding
    implements com.google.protobuf.ProtocolMessageEnum {
  /**
   * <code>UNKNOWN_ENCODING = 0;</code>
   */
  UNKNOWN_ENCODING(0),
  /**
   * <pre>
   * The signature's format is r || s, where r and s are zero-padded and have
   * the same size in bytes as the order of the curve. For example, for NIST
   * P-256 curve, r and s are zero-padded to 32 bytes.
   * </pre>
   *
   * <code>IEEE_P1363 = 1;</code>
   */
  IEEE_P1363(1),
  /**
   * <pre>
   * The signature is encoded using ASN.1
   * (https://tools.ietf.org/html/rfc5480#appendix-A):
   * ECDSA-Sig-Value :: = SEQUENCE {
   *  r INTEGER,
   *  s INTEGER
   * }
   * </pre>
   *
   * <code>DER = 2;</code>
   */
  DER(2),
  UNRECOGNIZED(-1),
  ;

  /**
   * <code>UNKNOWN_ENCODING = 0;</code>
   */
  public static final int UNKNOWN_ENCODING_VALUE = 0;
  /**
   * <pre>
   * The signature's format is r || s, where r and s are zero-padded and have
   * the same size in bytes as the order of the curve. For example, for NIST
   * P-256 curve, r and s are zero-padded to 32 bytes.
   * </pre>
   *
   * <code>IEEE_P1363 = 1;</code>
   */
  public static final int IEEE_P1363_VALUE = 1;
  /**
   * <pre>
   * The signature is encoded using ASN.1
   * (https://tools.ietf.org/html/rfc5480#appendix-A):
   * ECDSA-Sig-Value :: = SEQUENCE {
   *  r INTEGER,
   *  s INTEGER
   * }
   * </pre>
   *
   * <code>DER = 2;</code>
   */
  public static final int DER_VALUE = 2;


  public final int getNumber() {
    if (this == UNRECOGNIZED) {
      throw new java.lang.IllegalArgumentException(
          "Can't get the number of an unknown enum value.");
    }
    return value;
  }

  /**
   * @param value The numeric wire value of the corresponding enum entry.
   * @return The enum associated with the given numeric wire value.
   * @deprecated Use {@link #forNumber(int)} instead.
   */
  @java.lang.Deprecated
  public static EcdsaSignatureEncoding valueOf(int value) {
    return forNumber(value);
  }

  /**
   * @param value The numeric wire value of the corresponding enum entry.
   * @return The enum associated with the given numeric wire value.
   */
  public static EcdsaSignatureEncoding forNumber(int value) {
    switch (value) {
      case 0: return UNKNOWN_ENCODING;
      case 1: return IEEE_P1363;
      case 2: return DER;
      default: return null;
    }
  }

  public static com.google.protobuf.Internal.EnumLiteMap<EcdsaSignatureEncoding>
      internalGetValueMap() {
    return internalValueMap;
  }
  private static final com.google.protobuf.Internal.EnumLiteMap<
      EcdsaSignatureEncoding> internalValueMap =
        new com.google.protobuf.Internal.EnumLiteMap<EcdsaSignatureEncoding>() {
          public EcdsaSignatureEncoding findValueByNumber(int number) {
            return EcdsaSignatureEncoding.forNumber(number);
          }
        };

  public final com.google.protobuf.Descriptors.EnumValueDescriptor
      getValueDescriptor() {
    if (this == UNRECOGNIZED) {
      throw new java.lang.IllegalStateException(
          "Can't get the descriptor of an unrecognized enum value.");
    }
    return getDescriptor().getValues().get(ordinal());
  }
  public final com.google.protobuf.Descriptors.EnumDescriptor
      getDescriptorForType() {
    return getDescriptor();
  }
  public static final com.google.protobuf.Descriptors.EnumDescriptor
      getDescriptor() {
    return com.google.crypto.tink.proto.Ecdsa.getDescriptor().getEnumTypes().get(0);
  }

  private static final EcdsaSignatureEncoding[] VALUES = values();

  public static EcdsaSignatureEncoding valueOf(
      com.google.protobuf.Descriptors.EnumValueDescriptor desc) {
    if (desc.getType() != getDescriptor()) {
      throw new java.lang.IllegalArgumentException(
        "EnumValueDescriptor is not for this type.");
    }
    if (desc.getIndex() == -1) {
      return UNRECOGNIZED;
    }
    return VALUES[desc.getIndex()];
  }

  private final int value;

  private EcdsaSignatureEncoding(int value) {
    this.value = value;
  }

  // @@protoc_insertion_point(enum_scope:google.crypto.tink.EcdsaSignatureEncoding)
}

